package cam.dataxchg;
import java.io.*;
import java.util.*;


public class DoubleDataPackage implements Serializable
{

public DoubleDataPackage()
{
    data               = null;
    dimensions         = null;
    FortranStorageFlag = false;
}

public void setData(double [] D)
{
    if(D == null){data = null; return;}
    int dataSize = D.length;
    if(dataSize > 0)
    {
        data = new double[dataSize];
        for(int i = 0; i < dataSize; i++)
        data[i] = D[i];
    }
    dimensions = new int[1];
    dimensions[0] = dataSize;
    FortranStorageFlag = false;
}

public void setData(double [] D, int m, int n)
{
    if(D == null){data = null; return;}
    int dataSize = D.length;
    if(dataSize > 0)
    {
        data = new double[dataSize];
        for(int i = 0; i < dataSize; i++)
        data[i] = D[i];
    }
    dimensions = new int[2];
    dimensions[0] = m;
    dimensions[1] = n;
    FortranStorageFlag = false;
}

public void setData(double [][] D)
{
    if(D == null){data = null; return;}
    int m = 0;
    int n = 0;

    m  = D.length;
    if(m > 0)
    {n  = D[0].length;}

    if((m == 0)||(n == 0)) return;

    dimensions = new int[2];
    dimensions[0] = m;
    dimensions[1] = n;

    FortranStorageFlag = false;
    data = new double[m*n];

    int i; int j;

    for(i = 0; i < m; i++)
    {
    for(j = 0; j < n; j++)
    {
        data[j + i*n] = D[i][j];
    }}
}

public double [] getDataReference()
{
    return data;
}

public double [] getDataAs1DArray()
{
    if(data == null) return null;
    double [] returnData = new double[data.length];
    int i;
    for(i = 0; i < data.length; i++)
    {
        returnData[i] = data[i];
    }
    return returnData;
}

public double [][] getDataAs2DArray()
{
    if(data == null) return null;
    if(dimensions.length != 2 ) return null;
    double [][] returnData = new double[dimensions[0]][dimensions[1]];

    int i; int j;

    for(i = 0; i < dimensions[0]; i++)
    {
    for(j = 0; j < dimensions[1]; j++)
    {
         returnData[i][j] = data[j + i*dimensions[1]];
    }}

    return returnData;
}

public void input(InputStream D)
{
    StringTokenizer Tok;
    DataInputStream I = new DataInputStream(D);
    String line = null;

    try{line = I.readLine();}catch(IOException e){};
    Tok = new StringTokenizer(line);

    int dimCount = (new Integer(Tok.nextToken())).intValue();

    if(dimCount == 0)
    {
    data = null;
    return;
    }

    try{line = I.readLine();}catch(IOException e){};
    Tok = new StringTokenizer(line);

    if(dimCount == 1)
    {
    dimensions    = new int[1];
    dimensions[0] = (new Integer(Tok.nextToken())).intValue();
    }
    else
    if(dimCount == 2)
    {
    dimensions    = new int[2];
    dimensions[0] = (new Integer(Tok.nextToken())).intValue();
    dimensions[1] = (new Integer(Tok.nextToken())).intValue();
    }
    else{ return;}

    try{line = I.readLine();}catch(IOException e){};
    Tok = new StringTokenizer(line);

    int flagValue = (new Integer(Tok.nextToken())).intValue();
    FortranStorageFlag = false;
    if(flagValue == 1) FortranStorageFlag = true;

    int i; int j;
    if(dimensions.length == 1)
    {
    data = new double[dimensions[0]];
    for(i = 0; i < data.length; i++)
    {
    try{line = I.readLine();}catch(IOException e){};
    Tok = new StringTokenizer(line);
    data[i] = (new Double(Tok.nextToken())).doubleValue();
    }}

    if(dimensions.length == 2)
    {
    data = new double[dimensions[0]*dimensions[1]];
    for(i = 0; i < dimensions[0]; i++)
    {
    try{line = I.readLine();}catch(IOException e){};
    Tok = new StringTokenizer(line);
    for(j = 0; j < dimensions[1]; j++)
    {
       data[j + i*dimensions[1]] = (new Double(Tok.nextToken())).doubleValue();
    }}
    }

}
public void inputBinary(InputStream D)
{

    DataInputStream I  = new DataInputStream(D);
    int dimCount;
    try
    {
    dimCount = I.readInt();
    if(dimCount == 0) 
    {
    data = null;
    return;  
    }
    if(dimCount == 1)
    {
    dimensions    = new int[1];
    dimensions[0] = I.readInt();
    }
    else
    if(dimCount == 2)
    {
    dimensions    = new int[2];
    dimensions[0] = I.readInt();
    dimensions[1] = I.readInt();
    }
    else{ return;}

    int flagValue = I.readInt();
    FortranStorageFlag = false;
    if(flagValue == 1) FortranStorageFlag = true;

    int i; int j;
    if(dimensions.length == 1)
    {
    data = new double[dimensions[0]];
    for(i = 0; i < data.length; i++)
    {
    System.out.println(i);
    data[i] = I.readDouble();
    }}

    if(dimensions.length == 2)
    {
    data = new double[dimensions[0]*dimensions[1]];
    for(i = 0; i < dimensions[0]; i++)
    {
    for(j = 0; j < dimensions[1]; j++)
    {
       data[j + i*dimensions[1]] = I.readDouble();
    }}
    }
    }
    catch(IOException e){};

}
public void output(OutputStream O)
{
    PrintStream P = new PrintStream(O);

    if(data == null)
    {P.println(0); return;}
    int i; int j;

    // dimensions

    P.println(dimensions.length);

    for(i = 0; i < dimensions.length; i++) P.print(dimensions[i] + "  ");
    P.println();

    // Fortran storage flag

    if(FortranStorageFlag)
    {P.println(1);}
    else
    {P.println(0);}

    // data

    if(dimensions.length == 1)
    {
    for(i = 0; i < data.length; i++){P.println(data[i]);}
    }
    if(dimensions.length == 2)
    {
    for(i = 0; i < dimensions[0]; i++)
    {
    for(j = 0; j < dimensions[1]; j++)
    {
        P.print(data[j + i*dimensions[1]] + "  ");
    }
    P.println();
    }

    }
}
public void outputBinary(OutputStream D)
{
    DataOutputStream O = new DataOutputStream(D);
    int i; int j;
    
    
    if(data == null)
    {
    try{O.writeInt(0);}catch(IOException e){};   
    return;
    }

    // dimensions

    try{O.writeInt(dimensions.length);}catch(IOException e){};
    for(i = 0; i < dimensions.length; i++)
    try{O.writeInt(dimensions[i]);}catch(IOException e){};

    // Fortran storage flag

    if(FortranStorageFlag)
    {try{O.writeInt(1);}catch(IOException e){};}
    else
    {try{O.writeInt(0);}catch(IOException e){};}

    // data

    if(dimensions.length == 1)
    {
    for(i = 0; i < data.length; i++)
    {try{O.writeDouble(data[i]);}catch(IOException e){};}
    }
    if(dimensions.length == 2)
    {
    for(i = 0; i < dimensions[0]; i++)
    {
    for(j = 0; j < dimensions[1]; j++)
    {
        try{O.writeDouble(data[j + i*dimensions[1]]);}catch(IOException e){};
    }}

    }


}

public int [] getDimensions()
{
    if(dimensions == null) return null;
    return dimensions;
}

static public void main(String [] args)
{
    double [][] A = new double[5][3];
    DoubleDataPackage D = new DoubleDataPackage();

    int m = A.length;
    int n = A[0].length;
    int i; int j;

    for(i = 0; i < m; i++)
    {
    for(j = 0; j < n; j++)
    {
        A[i][j] = i+ j;
    }}
    D.setData(A);

    FileOutputStream Fout = null;
    try{Fout = new FileOutputStream("data.out");}catch(IOException e){};
    D.outputBinary(Fout);
    try{Fout.close();}catch(IOException e){};
    FileInputStream Fin = null;
    try{Fin = new FileInputStream("data.out");}catch(IOException e){};

    DoubleDataPackage D2 = new DoubleDataPackage();
    D2.inputBinary(Fin);
    D2.output(System.out);

    try{System.in.read(); }catch(IOException e){};
}
    private double[] data;
    private int []           dimensions;
    private boolean FortranStorageFlag;
}