package cam.dataxchg;
import java.util.*;
import java.io.*;
//
//##################################################################
//  		       Class ParameterList
//##################################################################
//
//	            Originator    : Chris Anderson 1996
//
//              Modifications :
//
//              Added stream input/output CRA 4/28/97
//              Added serialization       CRA 9/21/97
//
//              (C) UCLA
//
//##################################################################
//
//
// The index of elements in the list
// runs from 1 to number of items
//
public class ParameterList implements Serializable
{

private String Name;
private Vector parameterNames;       // for parameter names
private Vector parameterValues;      // for parameter values


public ParameterList()
{
    Name = new String("Parameters");
    parameterNames  = new Vector(5);
    parameterValues = new Vector(5);
}

public  ParameterList(ParameterList P)
{
    Name           = new String(P.getListName());
    int iCount     =  P.getItemCount();

    parameterNames  = new Vector(iCount);
    parameterValues = new Vector(iCount);
    
    int i;
    for(i = 1; i <= iCount; i++)
    {
    addObject(new String(P.getItemName(i)), 
    P.getObject(P.getItemName(i)));
    }
}
public ParameterList(String S)
{
    Name = new String(S);
    parameterNames  = new Vector(5);
    parameterValues = new Vector(5);
}

public void Initialize()
{
    Name = new String("Parameters");
    parameterNames  = new Vector(5);
    parameterValues = new Vector(5);

}

public void Initialize(String S)
{
    Name = new String(S);
    parameterNames  = new Vector(5);
    parameterValues = new Vector(5);

}

public final String getListName()
{
    return Name;
}

public final void setListName(String S)
{
    Name = new String(S);
}

//
//      Returns one of
//
//      java.lang.Boolean
//      java.lang.Character
//      java.lang.String
//      java.lang.Integer
//      java.lang.Long
//      java.lang.Float
//      java.lang.Double
//      Object Class Name
//



public final String getItemType(String Name)
{

    int i = parameterNames.indexOf(Name);
    return ((parameterValues.elementAt(i)).getClass()).getName();
}

public final String getItemType(int i)
{
    return ((parameterValues.elementAt(i-1)).getClass()).getName();
}

public final int getItemCount()
{
    return parameterNames.size();
}

public final String getItemName(int i)
{
    if( i <= 0 || i > getItemCount()) return "";
    return (String)parameterNames.elementAt(i-1);
}

public final Object getItemValue(int i)
{
    if( i <= 0 || i > getItemCount()) return null;
    return parameterValues.elementAt(i-1);
}

public final String getItemValueAsString(int i)
{
    if( i <= 0 || i > getItemCount()) return null;
    String Type = ((parameterValues.elementAt(i-1)).getClass()).getName();
    if(Type.equals("java.lang.Boolean"))
    {
       return ((Boolean)(parameterValues.elementAt(i-1))).toString();
    }
    else if(Type.equals("java.lang.Character"))
    {
       return ((Character)(parameterValues.elementAt(i-1))).toString();
    }
    else if(Type.equals("java.lang.String"))
    {
       return ((String)(parameterValues.elementAt(i-1)));
    }
    else if(Type.equals("java.lang.Integer"))
    {
       return ((Integer)(parameterValues.elementAt(i-1))).toString();
    }
    else if(Type.equals("java.lang.Long"))
    {
       return ((Long)(parameterValues.elementAt(i-1))).toString();
    }
    else if(Type.equals("java.lang.Float"))
    {
       return ((Float)(parameterValues.elementAt(i-1))).toString();
    }
    else if(Type.equals("java.lang.Double"))
    {
       return ((Double)parameterValues.elementAt(i-1)).toString();
    }
    return null;
}

public final void addBoolean(String Name, boolean def)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Boolean(def));
}
public final void addBoolean(String Name)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Boolean(false));
}
public final boolean getBoolean(String Name)
{
    int i = parameterNames.indexOf(Name);
    return ((Boolean)(parameterValues.elementAt(i))).booleanValue();
}

public final void setBoolean(String Name,boolean val)
{
    int i = parameterNames.indexOf(Name);
    parameterValues.setElementAt(new Boolean(val),i);
}

public final void setBoolean(int i,boolean val)
{
    parameterValues.setElementAt(new Boolean(val),i-1);
}

public final void setBoolean(int i, String val)
{
    parameterValues.setElementAt(new Boolean(val),i-1);
}


public final void addChar(String Name, char def)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Character(def));
}
public final void addChar(String Name)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Character('\u0000'));
}
public final char getChar(String Name)
{
    int i = parameterNames.indexOf(Name);
    return ((Character)(parameterValues.elementAt(i))).charValue();
}
public final void setChar(String Name,char val)
{
    int i = parameterNames.indexOf(Name);
    parameterValues.setElementAt(new Character(val),i);
}

public final void setChar(int i,char val)
{
    parameterValues.setElementAt(new Character(val),i-1);
}

public final void setChar(int i, String val)
{
    parameterValues.setElementAt(new Character(val.charAt(0)),i-1);
}


public final void addString(String Name, String def)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new String(def));
}
public final void addString(String Name)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new String(""));
}
public final String getString(String Name)
{
    int i = parameterNames.indexOf(Name);
    return ((String)(parameterValues.elementAt(i)));
}
public final void setString(String Name, String val)
{
    int i = parameterNames.indexOf(Name);
    parameterValues.setElementAt(new String(val),i);
}

public final void setString(int i, String val)
{
    parameterValues.setElementAt(new String(val),i-1);
}

public final void addInt(String Name, int def)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Integer(def));
}
public final void addInt(String Name)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Integer(0));
}
public final int getInt(String Name)
{
    int i = parameterNames.indexOf(Name);
    return ((Integer)(parameterValues.elementAt(i))).intValue();
}

public final void setInt(String Name,int val)
{
    int i = parameterNames.indexOf(Name);
    parameterValues.setElementAt(new Integer(val),i);
}

public final void setInt(int i,int val)
{
   parameterValues.setElementAt(new Integer(val),i-1);
}

public final void setInt(int i,String val)
{
   parameterValues.setElementAt(new Integer(val),i-1);
}

public final void addLong(String Name, long def)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Long(def));
}
public final void addLong(String Name)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Long(0));
}
public final long getLong(String Name)
{
    int i = parameterNames.indexOf(Name);
    return ((Long)(parameterValues.elementAt(i))).longValue();
}
public final void setLong(String Name,long val)
{
    int i = parameterNames.indexOf(Name);
    parameterValues.setElementAt(new Long(val),i);
}

public final void setLong(int i,long val)
{
    parameterValues.setElementAt(new Long(val),i-1);
}

public final void setLong(int i,String val)
{
    parameterValues.setElementAt(new Long(val),i-1);
}


public final void addFloat(String Name, float def)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Float(def));
}
public final void addFloat(String Name)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Float(0));
}
public final float getFloat(String Name)
{
    int i = parameterNames.indexOf(Name);
    return ((Float)(parameterValues.elementAt(i))).floatValue();
}
public final void setFloat(String Name,float val)
{
    int i = parameterNames.indexOf(Name);
    parameterValues.setElementAt(new Float(val),i);
}

public final void setFloat(int i,float val)
{
    parameterValues.setElementAt(new Float(val),i-1);
}

public final void setFloat(int i,String val)
{
    parameterValues.setElementAt(new Float(val),i-1);
}


public final void addDouble(String Name, double def)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Double(def));
}
public final void addDouble(String Name)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(new Double(0));
}
public final double getDouble(String Name)
{
    int i = parameterNames.indexOf(Name);
    return ((Double)(parameterValues.elementAt(i))).doubleValue();
}
public final void setDouble(String Name,double val)
{
    int i = parameterNames.indexOf(Name);
    parameterValues.setElementAt(new Double(val),i);
}

public final void setDouble(int i,double val)
{
    parameterValues.setElementAt(new Double(val),i-1);
}

public final void setDouble(int i,String val)
{
    parameterValues.setElementAt(new Double(val),i-1);
}


public final void addObject(String Name, Object def)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(def);
}
public final void addObject(String Name)
{
    parameterNames.addElement(Name);
    parameterValues.addElement(null);
}
public final Object getObject(String Name)
{
    int i = parameterNames.indexOf(Name);
    return parameterValues.elementAt(i);
}
public final void setObject(String Name, Object val)
{
    int i = parameterNames.indexOf(Name);
    parameterValues.setElementAt(val,i);
}

public final void setObject(int i, Object val)
{
    parameterValues.setElementAt(val,i-1);
}


public void output(OutputStream D)
{
    PrintWriter O = new PrintWriter(D,true);

    O.println(getListName());

    int iCount = getItemCount();
    O.println(iCount);

    int i;
    for(i = 1; i <= iCount; i++)
    {
    O.println(getItemType(i) + " " +
              getItemName(i) + " " +
              getItemValueAsString(i)
              );
    }

}

public void outputBinary(OutputStream D)
{
    DataOutputStream O = new DataOutputStream(D);

    try{O.writeUTF(getListName());} catch(Exception e){System.out.println(e);};

    int iCount = getItemCount();
    try{O.writeInt(iCount);} catch(Exception e){System.out.println(e);};


    int i;
    String type = null;
    String name = null;

    try
    {

    for(i = 1; i <= iCount; i++)
    {
    type = getItemType(i);
    name = getItemName(i);
    O.writeUTF(type);
    O.writeUTF(name);

    if(type.equals("java.lang.Boolean"))
    {
    O.writeBoolean(getBoolean(name));
    }
    else if(type.equals("java.lang.Integer"))
    {
    O.writeInt(getInt(name));
    }
    else if(type.equals("java.lang.Long"))
    {
    O.writeLong(getLong(name));
    }
    else if(type.equals("java.lang.Float"))
    {
    O.writeFloat(getFloat(name));
    }
    else if(type.equals("java.lang.Double"))
    {
    O.writeDouble(getDouble(name));
    }
    else if(type.equals("java.lang.Character"))
    {
    O.writeChar(getChar(name));
    }
    else if(type.equals("java.lang.String"))
    {
    O.writeUTF(getString(name));
    }
    else{}
    }

    } // try
    catch(Exception e){System.out.println(e);};
}


public void input(InputStream D)
{
    DataInputStream I = new DataInputStream(D);
    StringTokenizer Tok;

    String line = null;
    try{line = I.readLine();} catch(Exception e){System.out.println(e);};

    if(line != null) Initialize(line);
    else Initialize();

    try{line = I.readLine();} catch(Exception e){System.out.println(e);};
    int itemCount = (new Integer(line)).intValue();


    int i;
    String type;
    String name;
    String value;

    for(i = 1; i <= itemCount; i++)
    {
    try{line = I.readLine();} catch(Exception e){System.out.println(e);};
    Tok = new StringTokenizer(line,"  ");
    type  = Tok.nextToken();
    name  = Tok.nextToken();
    value = Tok.nextToken();
    if(type.equals("java.lang.Boolean"))
    {
    addBoolean(name,(new Boolean(value)).booleanValue());
    }
    else if(type.equals("java.lang.Integer"))
    {
    addInt(name,(new Integer(value)).intValue());
    }
    else if(type.equals("java.lang.Long"))
    {
    addLong(name,(new Long(value)).longValue());
    }
    else if(type.equals("java.lang.Float"))
    {
    addFloat(name,(new Float(value)).floatValue());
    }
    else if(type.equals("java.lang.Double"))
    {
    addDouble(name,(new Double(value)).doubleValue());
    }
    else if(type.equals("java.lang.Character"))
    {
    addChar(name,(new Character(value.charAt(0))).charValue());
    }
    else if(type.equals("java.lang.String"))
    {
    addString(name,value);
    }
    else{}

    }


}

public void inputBinary(InputStream D)
{
    DataInputStream I = new DataInputStream(D);

    String line = null;
    try{line = I.readUTF();} catch(Exception e){};

    if(line != null) Initialize(line);
    else Initialize();

    int iCount = 0;
    try{iCount = I.readInt();} catch(Exception e){};


    int i;
    String type = null;
    String name = null;

    try{

    for(i = 1; i <= iCount; i++)
    {
    type = I.readUTF();
    name = I.readUTF();

    if(type.equals("java.lang.Boolean"))
    {
    addBoolean(name,I.readBoolean());
    }
    else if(type.equals("java.lang.Integer"))
    {
    addInt(name,I.readInt());
    }
    else if(type.equals("java.lang.Long"))
    {
    addLong(name,I.readLong());
    }
    else if(type.equals("java.lang.Float"))
    {
    addFloat(name,I.readFloat());
    }
    else if(type.equals("java.lang.Double"))
    {
    addDouble(name,I.readDouble());
    }
    else if(type.equals("java.lang.Character"))
    {
    addChar(name,I.readChar());
    }
    else if(type.equals("java.lang.String"))
    {
    addString(name,I.readUTF());
    }
    else{}
    }

    } // try
    catch(Exception e){};
}


public static void main(String argv [])
{
    ParameterList P = new ParameterList("Colors");
//
//  test one of every type
//
    P.addBoolean("hidden",true);
    P.addChar("Initial",'c');
    P.addString("Names","blue");
    P.addInt("visable", 1);
    P.addLong("non-visable", 3);
    P.addFloat("saturation",(float)(.001));
    P.addDouble("hue",3.00089);

    P.output(System.out);


    FileOutputStream F = null;
    try{F = new FileOutputStream("Test.para");}catch(Exception e){};
    P.outputBinary(F);
    try{F.close();}catch(Exception e){};


    FileInputStream Fin = null;
    try{Fin = new FileInputStream("Test.para");}catch(Exception e){};

    ParameterList Q = new ParameterList();
    Q.inputBinary(Fin);

    Q.output(System.out);

    try{System.in.read();}catch(Exception e){};


}

}
