//
//###################################################################
//                   Class ParameterListTest
//###################################################################
//
//  A sample program that uses the cam.dataxchg.ParameterList class.
//
//  Creator               : Chris Anderson
//  (C) UCLA 1997
//
//###################################################################
//
import cam.dataxchg.*;
import java.io.DataInputStream;


public class ParameterListTest
{

public ParameterListTest(){}

public void resetParameters(ParameterList L)
{
//
//  reset the parameters in L
//
    L.setDouble("diffusivity",.1);
    L.setDouble("a",0);
    L.setDouble("b",19);
    L.setInt("m",100);
    L.setInt("nSteps",1000);
}

public static void main(String[] args)
{
    ParameterListTest Ptest = new ParameterListTest();
//
//  Create a list of parameters
//
    ParameterList L = new ParameterList("Runtime Parameters");
    L.addDouble("diffusivity",.05);
    L.addDouble("a",0);
    L.addDouble("b",1);
    L.addInt("m",10);
    L.addInt("nSteps",100);
//
//  Output to the console
//
    L.output(System.out);
    System.out.println("  ");
//
//  Demonstration of passing the parameter list ...
//
    Ptest.resetParameters(L);
//
//  See results on the console
//
    System.out.println("Reset Parameters :");
    System.out.println(" ");
    L.output(System.out);
//
//  Wait for input to terminate the program (this is a workaround 
//  for IDE's that close the console window at the programs end
//
    DataInputStream D = new DataInputStream(System.in);
    try{D.read();}catch(Exception e){};
}

}
